/* GCC */
#include <iostream>

using namespace std; 

int T, n, x_p, x_n, z_size, dist[100010], inv_dist[100010], s[200020], z[200020];
bool pol[100010], inv_pol[100010];

void z_function()
{
    int L = -1, R = -1;
    memset( z, 0, 800080 );
    for( int i = 2; i <= z_size; i++ )
    {
        if( i <= R ) z[i] = std::min( z[i - L + 1], R - i + 1 );
        for( ; ( i + z[i] <= z_size ) && ( s[i + z[i]] == s[z[i] + 1] ); z[i]++ );
        if( i + z[i] - 1 > R ) R = i + z[i] - 1, L = i;
    }
    return;
}

int main()
{
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    scanf("%d", &T);
    for( ; T > 0; T-- )
    {
        int i = 1;
        memset( pol, 0, 100010 );
        memset( inv_pol, 0, 100010 );
        
        scanf("%d%d", &n, &x_p);
        for( ; i < n; i++ )
        {
            scanf("%d", &x_n);
            dist[i] = x_n - x_p;
            inv_dist[n - i] = dist[i];
            x_p = x_n;
        }
        
        n--;
        z_size = ( n << 1 ) + 1;
        s[n + 1] = -1;
        pol[0] = inv_pol[0] = pol[n + 1] = inv_pol[n + 1] = 1;
        
        for( i = 1; i <= n; i++ ) s[i] = inv_dist[i], s[n + 1 + i] = dist[i];
        
        z_function();
        for( i = n + 2; i <= z_size; i++ ) inv_pol[i - n - 1] = ( ( z[i] + i - 1 ) == z_size );
        
        for( i = 1; i <= n; i++ ) s[i] = dist[i], s[n + 1 + i] = inv_dist[i];
        
        z_function();
        for( i = n + 2; i <= z_size; i++ ) pol[z_size - i + 1] = ( ( z[i] + i - 1 ) == z_size );
        
        for( i = 0; i < n; i++ )
        {
            if( pol[i] && inv_pol[i + 2] )
            {
                printf("%d\n", i + 1);
                break;
            }
        }
        if( i == n ) printf("0\n");
    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}
