{ Free Pascal }

Program Aliens;
const as_suff = 1;
      as_pref = 2;
type TSlovo = array [1..10] of byte;

var o: text;
    price: array [1..10,1..16] of longint;
    N,M,jn,cm: byte;
    K: longint;
    prf,slovo: TSlovo;
    sum_suf: array [0..1048577] of longint;
    suf_num: longint;

function calculatecost(l: byte; mode: byte): longint;
var s: longint;                       j,i: byte;      begin
S:=0;
if mode = as_pref then
                    for j:=1 to l do S:=S+price[j,slovo[j]];
if mode = as_suff then
                for j:=L downto 1 do begin
                i:=n;
                S:=S+price[i,slovo[j]];
                dec(i);                end;
calculatecost:=S;                                       end;

procedure suffixgenerate(k: byte; max_l: byte);
label NEXTk,NEXTj;
var S: byte;
    j: byte;
                                                      begin
S:=max_l;
if k>S then begin inc(suf_num);
                  sum_suf[suf_num]:=calculatecost(k-1,as_suff);
                  exit; end;

for j:=1 to N do begin
                 slovo[k]:=j;
                 SuffixGenerate(k+1,max_l);
                 end;                                   end;

function _H(x: longint): longint;
var l,r,t: longint;                                   begin

l:=1;
r:=suf_num;
if x<sum_suf[r] then begin _h:=0; exit end;

while (r-l>1) do                begin
      t:=(l+r) div 2;
      if x<sum_suf[t] then r:=t
                      else l:=t;  end;
_h:=L;                                                  end;

function SmallerNum(x: longint): longint; begin SmallerNum:=_h(x); end;
function BiggerNum(x: longint): longint;  begin BiggerNum:=Suf_num - _h(x+1); end;
function equalnum(x: longint): longint;   begin equalnum:=_h(x+1)-_h(x); end;

{---------} const NeedBigger = 1; NeedEqual = 2; NeedSmaller = 3;
{---------}
{---------} var COMMAND_BUFFER: byte;
{---------} var count: longint;  // count(SUM: SUM> SUM(prefix)+SUM(suffix)=x)
{---------}


procedure wordgenerate(x: longint;
                       k: longint; Max_L: byte);
var j: byte; S: byte; sum: longint;
begin
S:=Max_l;
if k>S then begin
            sum:=calculatecost(k-1,as_pref);
            if SUM=X then inc(count);
            exit;
            end;

sum:=calculatecost(k-1,as_pref);
if sum>x then exit;

for j:=1 to N do begin slovo[k]:=j;
                       wordgenerate(x,k+1,max_l);
                       end;
end;

procedure prefixgenerate(x: longint;
                         k: longint; max_l: byte; mode: byte);
var j: byte;  S: byte; sum,req: longint;
begin
S:=Max_l;

if k>s then begin sum:=calculatecost(k-1,as_pref);
                  if mode=NeedBigger then req:=BiggerNum(x-sum);
                  if mode=NeedEqual then req:=EqualNum(x-sum);

                  count:=count+req; exit   end;

for j:=1 to N do begin slovo[k]:=j;
                       prefixgenerate(x,k+1,max_l, mode); end;
end;


function _F(x: longint): longint;
                                                      begin
count:=0;
prefixgenerate(x, 1, M-(M div 2)-1, NeedBigger);
_F:=count;                                              end;
{----------}
{----------}
{----------}


function _G(x: longint; st: Tslovo; lenS: byte): longint;
var l: byte; max_l: byte;
    sum1,sum2: longint;
                                                      begin
max_l:=M-(M div 2);  count:=0;

if lenS<=(M-(M div 2)) then begin
for l:=1 to LenS do slovo[l]:=st[l];
PrefixGenerate(x, LenS+1, M-(M div 2), NeedEqual);
_G:=count;
exit;               end;

if LenS>(M-(M div 2))  then begin
for l:=1 to LenS do Slovo[l]:=st[l];
wordgenerate(x, lenS+1, M);
_G:=count;
exit;                         end;
                                                        end;

procedure qsort(left,right: longint);
var l,r,t,z: longint;                                 begin
l:=left;
r:=right;   t:=(l+r) div 2;
repeat while sum_suf[l]<sum_suf[t] do inc(l);
       while sum_suf[t]<sum_suf[r] do dec(r);
       if l<=r then begin z:=sum_suf[l]; sum_suf[l]:=sum_suf[r]; sum_suf[r]:=z; inc(l); dec(r); end;
 until l>r;
if l<right then qsort(l,right);
if left<r  then qsort(left,r);                          end;

function findminword: longint;
var i,j: longint;   min: longint; sum: longint;       begin
sum:=0;
for i:=1 to M do begin
min:=1000000; for j:=1 to N do if price[i,j]<min
                                then min:=price[i,j];
sum:=sum+min;                                           end;
findminword:=sum;                                       end;

function findmaxword: longint;
var i,j: longint;   max: longint; sum: longint;       begin
sum:=0;
for i:=1 to M do begin
max:=0; for j:=1 to N do if price[i,j]>max
                                then max:=price[i,j];
sum:=sum+max;                                           end;
findmaxword:=sum;                                       end;

var A,B,pA,pB,pC,C,L,L1,fC: longint;
    ST: Tslovo;
                                                      BEGIN
assign(o,'aliens.in');  reset(o);
readln(o,N,M,K);                    writeln(m);
                                    for jn:=1 to M do begin
for cm:=1 to N do read(o,price[jn,cm]);  readln(o);     end;
close(o);
assign(o,'aliens.out'); rewrite(o);

Suf_num:=0;  SuffixGenerate(1,(M div 2));
qsort(1,suf_num);

A:=FindMinWord;
B:=FindMaxWord;
C:=A;
while (_F(C)<K) and (C<=B) do inc(C);
writeln(c);

pA:=_F(A);
pB:=_F(B);

writeln(a,' ',b);

while (B-A)>1 do begin
                 C:=(A+B) div 2;
                 if K>_F(C) then A:=C
                            else B:=C;
                 end;
writeln(_F(18));
writeln(a,' ',b);
randomize;

for A:=1 to M do write(o,chr(ord('a')+(random(1244) mod N)));
writeln(o);

close(o);
                                                        END.

