/* GCC */
#include <iostream>
#include<cstdio>
#include<algorithm>
#include<map>
#include<string>
using namespace std;
int mas[20][20];
map<int,int> Ma;
int n,m2,m,k;
long long pref[1050000];
long long suf[1050000];
int prefc;
int sufc;

void suf_gen(int level,int sum)
{
    if (level==m2)
    {
        suf[sufc++]=sum;
        return;
    }
    for(int i=0;i<n;i++)
        suf_gen(level+1,sum+mas[i][level]);
}
void pref_gen(int level,int sum)
{
    if (level==m)
    {
        pref[prefc++]=sum;
        Ma[sum]++;
        return;
    }
    for(int i=0;i<n;i++)
        pref_gen(level+1,sum+mas[i][level]);
}
long long g(int x)
{
    int r;
    r=0;
    long long ans=0;
    for(int i=sufc-1;i>=0;i--)
    {
        while(suf[i]+pref[r]<=x && r<prefc)
        {
            r++;
        }
        ans+=prefc-r;
    }
    return ans;
}
int po(int level,int sum)
{
    if(sum<0)
        return 0;
    if(level==m2)
        return Ma[sum];
    if(level==m && sum==0)
        return 1;
    if(level>=m)
        return 0;
    long long ans=0;
    for(int i=0;i<n;i++)
        ans+=po(level+1,sum-mas[i][level]);
    return ans;
}

int main()
{
    freopen("aliens.in","r",stdin);
    freopen("aliens.out","w",stdout);
    cin>>n>>m>>k;
    m2=m/2;
    for(int i=0;i<m;i++)
        for(int j=0;j<n;j++)
    {
        scanf("%d",&mas[j][i]);
    }
    suf_gen(0,0);
    pref_gen(m2,0);
    sort(suf,suf+sufc);
    sort(pref,pref+prefc);
    int l=0;
    int r=2000000000;
    while(r-l>1)
    {
        int cost=(r+l)/2;
        int t=g(cost);
        if(g(cost)<k)
        {
            r=cost;
        }
        else
        {
            l=cost;
        }
    }
    int anscost=r;
    string s="";
    k-=g(anscost+1);
    for(int i=0;i<m;i++)
    {
        for(int j=0;j<n;j++)
        {
            int d=po(i+1,anscost-mas[j][i]);
            if(d<k)
            {
                k-=d;
            }
            else
            {
                s+=j+'a';
                anscost-=mas[j][i];
                break;
            }
        }
    }
    cout<<s<<endl;
    return 0;
}
