/* GCC */
#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#define name "aliens"
using namespace std;
const int DEBUG = 0;
struct word{string w; int cost;};
vector<string> dict;
vector<word> tdict;
int costs[17][11];

void generateWords(int M, int N, string prefix = ""){
  if (M == 0){ dict.push_back(prefix); return; }
  for(int ch = 'a'; ch < N+'a'; ch++){
    generateWords(M-1, N, prefix+(char)ch);
  }
}

int getCost(string a){
    int ans = 0;
    for(int i = 0; i < a.length(); i++)
      ans += costs[i][a[i]-'a'];
    return ans;
}

void generateCosts(){
  for(int i = 0; i < dict.size(); i++){
    int c = getCost(dict[i]);
    word a; a.w = dict[i];
    a.cost = c;
    tdict.push_back(a);
  }
}

bool comp(word a, word b){
     return ((a.cost > b.cost) || (a.cost == b.cost && (a.w < b.w)));
}

int main(){
    if (!DEBUG){
      freopen(name ".in", "r", stdin);
      freopen(name ".out", "w", stdout);
    }
    int N, M, K; scanf("%d %d %d", &N, &M, &K);
    for(int i = 0; i < M; i++) for(int j = 0; j < N; j++) scanf("%d", &costs[i][j]);
    generateWords(M, N);
    generateCosts();
    sort(tdict.begin(), tdict.end(), comp);
    cout<<tdict[K-1].w<<endl;
    if (DEBUG) system("pause");
}
